<?php


namespace App\Http\Bean\Cron\logic;


use App\Http\Bean\BaseBean;

class HandleOrderParamBean extends BaseBean
{
    /**
     * 订单编号
     * @var string $orderNumber
     */
    private $orderNumber;

    /**
     * 支付时间(Y-m-d H:i:s)
     * @var string $payTime
     */
    private $payTime;

    /**
     * 订单用户实际支付金额(单位为分)
     * @var string $orderPrice
     */
    private $orderPrice;

    /**
     * 订单佣金(单位为分)
     * @var string $orderCommission
     */
    private $orderCommission;

    /**
     * 用户推广位ID
     * @var string $userSpreadId
     */
    private $userSpreadId;

    /**
     * 平台推广位ID
     * @var string $platformSpreadId
     */
    private $platformSpreadId;

    /**
     * 订单标题
     * @var string $orderTitle
     */
    private $orderTitle;

    /**
     * 订单退款金额(单位为分)
     * @var string $orderRefundPrice
     */
    private $orderRefundPrice;

    /**
     * 订单退款时间(Y-m-d H:i:s)
     * @var string $orderRefundTime;
     */
    private $orderRefundTime;

    /**
     * 订单退款扣除的佣金(单位为分)
     * @var string $orderRefundCommission
     */
    private $orderRefundCommission;

    /**
     * 订单状态(详情参考OrderStatusEnum枚举类)
     * @var string $orderStatus
     */
    private $orderStatus;

    /**
     * 订单优惠券
     * @var string $orderCouponPrice
     */
    private $orderCouponPrice;

    /**
     * 渠道ID(目前只有淘宝存在)
     * @var string $orderChannelId
     */
    private $orderChannelId;

    /**
     * 商品图片
     * @var string $productImgUrl
     */
    private $productImgUrl;

    /**
     * 推广位平台(详情参考PlatformTypeEnum枚举类)
     * @var $platformType int
     */
    private $spreadType;

    /**
     * 推广子平台(详情参考PlatformTypeSonEnum枚举类)
     * @var int $spreadSonType
     */
    private $spreadSonType;

    /**
     * 订单创建时间
     */
    private $createdAt;

    /**
     * @return mixed
     */
    public function getCreatedAt()
    {
        return $this->createdAt;
    }

    /**
     * @param mixed $createdAt
     */
    public function setCreatedAt($createdAt): void
    {
        $this->createdAt = $createdAt;
    }

    /**
     * @return string
     */
    public function getOrderNumber()
    {
        return $this->orderNumber;
    }

    /**
     * @param string $orderNumber
     */
    public function setOrderNumber(string $orderNumber): void
    {
        $this->orderNumber = $orderNumber;
    }

    /**
     * @return string
     */
    public function getPayTime()
    {
        return $this->payTime;
    }

    /**
     * @param string $payTime
     */
    public function setPayTime($payTime): void
    {
        $this->payTime = $payTime;
    }

    /**
     * @return string
     */
    public function getOrderPrice()
    {
        return $this->orderPrice;
    }

    /**
     * @param string $orderPrice
     */
    public function setOrderPrice($orderPrice): void
    {
        $this->orderPrice = $orderPrice;
    }

    /**
     * @return string
     */
    public function getOrderCommission()
    {
        return $this->orderCommission;
    }

    /**
     * @param string $orderCommission
     */
    public function setOrderCommission($orderCommission): void
    {
        $this->orderCommission = $orderCommission;
    }

    /**
     * @return string
     */
    public function getUserSpreadId()
    {
        return $this->userSpreadId;
    }

    /**
     * @param string $userSpreadId
     */
    public function setUserSpreadId($userSpreadId): void
    {
        $this->userSpreadId = $userSpreadId;
    }

    /**
     * @return string
     */
    public function getPlatformSpreadId()
    {
        return $this->platformSpreadId;
    }

    /**
     * @param string $platformSpreadId
     */
    public function setPlatformSpreadId($platformSpreadId): void
    {
        $this->platformSpreadId = $platformSpreadId;
    }

    /**
     * @return string
     */
    public function getOrderTitle()
    {
        return $this->orderTitle;
    }

    /**
     * @param string $orderTitle
     */
    public function setOrderTitle($orderTitle): void
    {
        $this->orderTitle = $orderTitle;
    }

    /**
     * @return string
     */
    public function getOrderRefundPrice()
    {
        return $this->orderRefundPrice;
    }

    /**
     * @param string $orderRefundPrice
     */
    public function setOrderRefundPrice($orderRefundPrice): void
    {
        $this->orderRefundPrice = $orderRefundPrice;
    }

    /**
     * @return string
     */
    public function getOrderRefundTime()
    {
        return $this->orderRefundTime;
    }

    /**
     * @param string $orderRefundTime
     */
    public function setOrderRefundTime($orderRefundTime): void
    {
        $this->orderRefundTime = $orderRefundTime;
    }

    /**
     * @return string
     */
    public function getOrderRefundCommission()
    {
        return $this->orderRefundCommission;
    }

    /**
     * @param string $orderRefundCommission
     */
    public function setOrderRefundCommission($orderRefundCommission): void
    {
        $this->orderRefundCommission = $orderRefundCommission;
    }

    /**
     * @return string
     */
    public function getOrderStatus()
    {
        return $this->orderStatus;
    }

    /**
     * @param string $orderStatus
     */
    public function setOrderStatus($orderStatus): void
    {
        $this->orderStatus = $orderStatus;
    }

    /**
     * @return string
     */
    public function getOrderCouponPrice(): string
    {
        return $this->orderCouponPrice;
    }

    /**
     * @param string $orderCouponPrice
     */
    public function setOrderCouponPrice(string $orderCouponPrice): void
    {
        $this->orderCouponPrice = $orderCouponPrice;
    }

    /**
     * @return string
     */
    public function getOrderChannelId(): string
    {
        return $this->orderChannelId;
    }

    /**
     * @param string $orderChannelId
     */
    public function setOrderChannelId(string $orderChannelId): void
    {
        $this->orderChannelId = $orderChannelId;
    }

    /**
     * @return string
     */
    public function getProductImgUrl(): string
    {
        return $this->productImgUrl;
    }

    /**
     * @param string $productImgUrl
     */
    public function setProductImgUrl(string $productImgUrl): void
    {
        $this->productImgUrl = $productImgUrl;
    }

    /**
     * @return int
     */
    public function getSpreadType(): int
    {
        return $this->spreadType;
    }

    /**
     * @param int $spreadType
     */
    public function setSpreadType(int $spreadType): void
    {
        $this->spreadType = $spreadType;
    }

    /**
     * @return int
     */
    public function getSpreadSonType(): int
    {
        return $this->spreadSonType;
    }

    /**
     * @param int $spreadSonType
     */
    public function setSpreadSonType(int $spreadSonType): void
    {
        $this->spreadSonType = $spreadSonType;
    }
}