<?php


namespace App\Http\Bean\Util\Pdd\Ddk;


use App\Http\Bean\BaseBean;

class OrderListIncrementGetParamBean extends BaseBean
{
    /**
     * 是否为礼金订单，查询礼金订单时，订单类型不填（默认推广订单）。
     */
    private $cashGiftOrder;


    /**
     * 查询结束时间，和开始时间相差不能超过24小时。note：此时间为时间戳，指格林威治时间 1970 年01 月 01 日 00 时 00 分 00 秒(北京时间 1970 年 01 月 01 日 08 时 00 分 00 秒)起至现在的总秒数
     */
    private $endUpdateTime;

    /**
     * 第几页
     */
    private $page;

    /**
     * 返回的每页结果订单数
     */
    private $pageSize;

    /**
     * 订单类型：1-推广订单；2-直播间订单
     */
    private $queryOrderType;

    /**
     * 是否返回总数，默认为true
     */
    private $returnCount;

    /**
     * 最近90天内多多进宝商品订单更新时间
     */
    private $startUpdateTime;

    /**
     * @return mixed
     */
    public function getCashGiftOrder()
    {
        return $this->cashGiftOrder;
    }

    /**
     * @param mixed $cashGiftOrder
     */
    public function setCashGiftOrder($cashGiftOrder): void
    {
        $this->cashGiftOrder = $cashGiftOrder;
    }

    /**
     * @return mixed
     */
    public function getEndUpdateTime()
    {
        return $this->endUpdateTime;
    }

    /**
     * @param mixed $endUpdateTime
     */
    public function setEndUpdateTime($endUpdateTime): void
    {
        $this->endUpdateTime = $endUpdateTime;
    }

    /**
     * @return mixed
     */
    public function getPage()
    {
        return $this->page;
    }

    /**
     * @param mixed $page
     */
    public function setPage($page): void
    {
        $this->page = $page;
    }

    /**
     * @return mixed
     */
    public function getPageSize()
    {
        return $this->pageSize;
    }

    /**
     * @param mixed $pageSize
     */
    public function setPageSize($pageSize): void
    {
        $this->pageSize = $pageSize;
    }

    /**
     * @return mixed
     */
    public function getQueryOrderType()
    {
        return $this->queryOrderType;
    }

    /**
     * @param mixed $queryOrderType
     */
    public function setQueryOrderType($queryOrderType): void
    {
        $this->queryOrderType = $queryOrderType;
    }

    /**
     * @return mixed
     */
    public function getReturnCount()
    {
        return $this->returnCount;
    }

    /**
     * @param mixed $returnCount
     */
    public function setReturnCount($returnCount): void
    {
        $this->returnCount = $returnCount;
    }

    /**
     * @return mixed
     */
    public function getStartUpdateTime()
    {
        return $this->startUpdateTime;
    }

    /**
     * @param mixed $startUpdateTime
     */
    public function setStartUpdateTime($startUpdateTime): void
    {
        $this->startUpdateTime = $startUpdateTime;
    }
}