<?php


namespace App\Http\Controllers\Cron;


use App\Http\Bean\Util\Jutuike\GetOrderListParamBean;
use App\Http\Controllers\BaseController;
use App\Http\Logic\Cron\CronLogic;
use App\Http\Utils\Jutuike\JutuikeUtil;

/**
 * 定时任务控制器
 * Class CronController
 * @package App\Http\Controllers\Cron
 */
class CronController extends BaseController
{
    /**
     * 获取美团订单
     */
    public function meituanOrders()
    {
        CronLogic::meituanOrderslogic();
        return $this->success();
    }

    /**
     * 获取聚推客订单
     */
    public function jutuikeOrders()
    {
        $datas = CronLogic::jutuikeOrdersLogic();
        return $this->success($datas);
    }

    /**
     * 定时获取淘宝订单
     */
    public function taobaoOrders()
    {
        CronLogic::taobaoOrdersLogic();
        return $this->success();
    }

    /**
     * 获取拼多多订单
     * @return \Illuminate\Http\JsonResponse
     */
    public function pddOrders()
    {
        CronLogic::pddOrdersLogic();
        return $this->success();
    }

    /**
     * 发送通知
     * @return \Illuminate\Http\JsonResponse
     */
    public function sendOrderTemplate()
    {
        CronLogic::sendOrderTemplateLogic();
        return $this->success();
    }

    /**
     * 结算订单佣金
     * @return \Illuminate\Http\JsonResponse
     */
    public function settlementOrderCommission()
    {
        CronLogic::settlementOrderCommissionLogic();
        return $this->success();
    }

    /**
     * 定时打款
     * @return \Illuminate\Http\JsonResponse
     */
    public function transferFinance()
    {
        CronLogic::transferFinanceLogic();
        return $this->success();
    }

    /**
     * 定时退款
     * @return \Illuminate\Http\JsonResponse
     */
    public function callbackCash()
    {
        CronLogic::callbackCashLogic();
        return $this->success();
    }
}